function Create(self)
    print("CREATED: " .. self.PresetName);

    --First, we need to find our actor (the dude holding the gun). When the orb first spawns, it should be near by.
    --This section of code searches though all the actors on the map and finds one that is within
    --25 pixels of the orb.  Since the create function is only executed once, this should cause any lag.
    --The actor's object reference is then saved to self.owner for later use.

    --Theoretically, the wrong actor could be found by this method.  However, chances are that won't happen,
    --and it's the only method for finding an actoravaliable in CC.  Besides, the insta-gib effect would rip
    --them apart at this range anyway.
    
    --Find actor
    for actor in MovableMan.Actors do
        --This code, and the one commented out, do exactly the same thing.  The one in use is just faster.
        if (actor.Pos - self.Pos).Magnitude < 50 then --math.abs(actor.Pos.X - self.Pos.X) < 25 and math.abs(actor.Pos.Y - self.Pos.Y) < 25 then
           self.owner = actor;
        end
    end

  --Now, lets make sure we were able to find our actor.  If not, we got a problem.
  --Also, we need to make sure the actor isn't already charging another orb.  Before I
  --put in the self.owner.pbc check, if I opened the console window while charging, then
  --I would fire again and start charging two orbs at once.  Then, when I let go of the trigger,
  --CC would say 'No' and crash to desktop.
  
  --If you try that now, the newer orb will instantly be gibbed (see below after the 'else'),
  --and the orb your already will be charge will not be affected. (does affect work here, or is it effect?  -_- fuck it).
  
  --HOWEVER!  If you were to open the console AND release the fire button at the same instant (before the orb gibs),
  --my guess is there might be trouble.  The likelyhood of this ever happening on accident is slim to none.

  if self.owner ~= nil and self.owner.pbc == nil then

    --save the orb as one of the actor's child variables.  That way, a different orb is able to check this variable.
    --If it were saved to self.pbc, the second orb's 'self' will be different from the frist orb's.  However, the
    --actor between them would be the same.

    self.owner.pbc = self;

    self.checkTimer = Timer(); --start a timer.  This time is used for increasing the scale of the orb at 0.1 second intervals.
    self.timer = Timer();  --start another timer.  This one is used to set a time delay on both keeping the orb in front of the gun, and sucking in particles.

    self.Scale = 0.1; --shrink the orb to 1 tenth it's normal size.

    self.Vel = Vector(0,0); --Stop it from moving.

    --Now, later we'll find it very helpful to know where our gun is currently located as the actor is moving around.
    --If a gun is laying on the gound, you can find it by going though the MovableMan.Items list, like we did above with MovableMan.Actors.
    --However, when the gun is in your hand, it is removed from that list.  So instead, we have to go though ALL the movable objects to find it.
    --We lets start from object 1 and count up =P.
    
    for i = 1, MovableMan:GetMOIDCount()-1, 1 do
        local gun = MovableMan:GetMOFromID(i);
        --If the preset name matches our gun's, and is nearby the orb, then let's save it for later use as self.gun.
        if gun.PresetName == "Particle Accelerator" then
           if math.abs(gun.Pos.X - self.Pos.X) < 25 and math.abs(gun.Pos.Y - self.Pos.Y) < 25 then
              self.gun = gun;
              
              --I found out that in Lua script, typecasting was an issue, even though Lua supports dynamic-type.
              --So we have to have our variable of the correct type, yet not be able to see what type we're working with o_O.
              --Also, CC's Lua does not seem to support the polymorphism in the engine's code very well.
              --This line of code here returns the guy who is holding our gun.  However, it is returned as a MovableObject type rather than an
              --Actor type.  This means we can't use any functions in Actor, which we need later on.
              --self.owner = MovableMan:GetMOFromID(gun.RootID);
           end
        end
    end

    --While working on this weapon, I learned that you can actually cast types by using To<ClassNameHere>(object);
    --So, if I wanted to cast a MovableObject to an Actor, and the object is an Actor, then all I had to do was
    --use this line of code:  self.owner = ToActor(MovableMan:GetMOFromID(gun.RootID));
    --Ah well, too late for that.  I might use it later on in a diffrent version.

    --Now, lets get the Emitter that was launched at the same time as our ball (as a Shell).
    --This is what provides the pretty glowy particles.  When the orb is destoried, we need to
    --get rid of this thing with it.  That's why we need to save it.
    --We'll use the same searching method as before for the actor.  But for particles this time.
    for ball in MovableMan.Particles do
        if ball.PresetName == "Particle Beam Emission Dummy" then
            if (ball.Pos - self.Pos).Magnitude < 30 then
                self.ball = ball;
                print(ball);
            end
        end
    end
    
  else
     self:GibThis();    --Safty measure I mentioned before.
  end
end

function Destroy(self)
    print("DESTROYED: " .. self.PresetName);
end

function Update(self)
  if self.owner:GetController():IsState(Controller.WEAPON_FIRE) then
    if self.gun == nil then
        self:GibThis();
    end
      if self.timer:IsPastSimMS(100) then
         if self.Scale < 1.5 then
             self.Scale = self.Scale + 0.05;
             self.timer:Reset();
         else
             self.Scale = 1.5;
         end
      end
    
    if self.checkTimer:IsPastSimMS(15) then
         local theta = ToActor(self.owner):GetAimAngle(true);
         self.Pos = self.gun.Pos + Vector(math.cos(theta)*30,math.sin(theta)*-30);

      if self.owner ~= nil then
           for actor in MovableMan.Actors do
              if actor.ID ~= self.owner.ID then
                  if (actor.Pos - self.Pos).Magnitude < (10 + (self.Scale * 7.5)) and self.Scale < 0.5 then --Gives it a range from 10 to 21.75.  1.5 is the max scale.
                      actor:GibThis();
                  end
              end
           end
         local power = (50 * (2 + self.Scale));
         for particle in MovableMan.Particles do
             if particle.PresetName ~= "Particle Beam Emission Dummy" then
                 if math.abs(particle.Pos.X - self.Pos.X) < power and math.abs(particle.Pos.Y - self.Pos.Y) < power then
                      local distVec = self.Pos - particle.Pos;
                      particle.Vel = particle.Vel + distVec:SetMagnitude(distVec.Magnitude/50);
                 end
             end
         end
      end
      self.checkTimer:Reset();
     end
   else
      self.owner.pbc = nil;
      local power = (100 * (2+self.Scale)); --(50 * (1 + self.Scale))
      for particle in MovableMan.Particles do
        local distVec = self.Pos - particle.Pos;
        if distVec.Magnitude < power then
           local theta = ToActor(self.owner):GetAimAngle(true);
           particle.Vel = Vector(math.cos(theta), -1* math.sin(theta)):SetMagnitude(self.Scale*50*power/distVec.Magnitude);
           --particle.Vel = particle.Vel - distVec:SetMagnitude(distVec.Magnitude*power);
        end
      end
        MovableMan:RemoveMO(self.ball);
        --self.burst = CreateMOSRotating("Muzzle Flash Burst PBC");
        --self.burst.Pos = self.Pos;
        --self.burst.RotAngle = ToActor(self.owner):GetAimAngle(true);
        --MovableMan:AddMO(self.burst);
        
        self:GibThis();
   end
end
